<template>
  <ObModal
    class="closing-contract-modal"
    ref="modal"
    size="small"
    title="Расторгнуть договор досрочно?"
    :is-error="true"
    ok-text="Расторгнуть"
    data-qa="signContract"
  >
    <ObForm
      :form-data="formData"
      :form-model="formModel"
      ok-text="Расторгнуть"
      :is-error="true"
      @submit="onSubmit"
    >
      <p>Вы хотите досрочно расторгнуть договор с контрагентом {{ participant }}?</p>
      <p>Дата окончания действия договора {{ toDate }}</p>
      <div class="sub-title">Дата досрочного расторжения</div>
      <ObDatePickerConstructor
        v-model="formData.closingDate"
        label="Дата досрочного расторжения"
      />
    </ObForm>
  </ObModal>
</template>

<script>
import ObModal from 'common-components/src/obComponents/obModal'
import ObForm from 'common-components/src/obComponents/obForm'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import moment from 'moment'
import { required } from 'vuelidate/lib/validators'

const isFuture = (value, vm) => {
  return Boolean(vm && (moment(value).startOf('day').diff(moment().startOf('day'), 'days') >= 1))
}

export default {
  name: 'ClosingContractModal',
  props: {
    participant: {
      type: String,
      default: ''
    },
    contract: {
      type: Object,
      default: () => {}
    }
  },
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObModal,
    ObDatePickerConstructor,
    ObForm
  },
  computed: {
    formModel () {
      return {
        closingDate: {
          value: '',
          validator: {
            required,
            isFuture: {
              method: isFuture,
              error: 'Дата должна быть в будущем'
            }
          }
        }
      }
    },
    toDate () {
      return this.contract.toDate ? moment(this.contract.toDate).format('DD.MM.YYYY') : 'бессрочно'
    }
  },
  methods: {
    open () {
      this.$refs.modal.open()
      setTimeout(() => {
        this.formData.closingDate = moment().add(1, 'day')
      }, 300)
    },
    close () {
      this.$refs.modal.close()
    },
    onSubmit () {
      this.$emit('on-submit', { uuid: this.contract.uuid, closingDate: this.formData.closingDate })
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';

  p {
    margin-top: 20px !important;
  }

  .sub-title {
    margin-top: 20px;
    margin-bottom: 10px;
    @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
  }
</style>
